using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace WindowsApplication1
{
    public class win32
    {
        public struct RECT
        {
            public Int32 left;
            public Int32 top;
            public Int32 right;
            public Int32 bottom;
            public void setrect(Int32 inleft, Int32 intop, Int32 inright, Int32 inbottom)
            {
                left = inleft;
                top = intop;
                right = inright;
                bottom = inbottom;
            }
            public RECT(Int32 ileft, Int32 itop, Int32 iright, Int32 ibottom)
            {
                left = ileft;
                top = itop;
                right = iright;
                bottom = ibottom;
            }
        }
        unsafe public struct LOGFONT
        {
            Int32 lfHeight;
            Int32 lfWidth;
            Int32 lfEscapement;
            Int32 lfOrientation;
            Int32 lfWeight;
            Byte lfItalic;
            Byte lfUnderline;
            Byte lfStrikeOut;
            Byte lfCharSet;
            Byte lfOutPrecision;
            Byte lfClipPrecision;
            Byte lfQuality;
            Byte lfPitchAndFamily;
            char* lfFaceName;
            public LOGFONT(Int32 Height, Int32 Width, Int32 Escapement, Int32 Orientation, Int32 Weight, Byte Italic, Byte Underline, Byte StrikeOut, Byte CharSet, Byte OutPrecision, Byte ClipPrecision, Byte Quality, Byte PitchAndFamily, char* FaceName)
            {
                lfHeight = Height;
                lfWidth = Width;
                lfEscapement = Escapement;
                lfOrientation = Orientation;
                lfWeight = Weight;
                lfItalic = Italic;
                lfUnderline = Underline;
                lfStrikeOut = StrikeOut;
                lfCharSet = CharSet;
                lfOutPrecision = OutPrecision;
                lfClipPrecision = ClipPrecision;
                lfQuality = Quality;
                lfPitchAndFamily = PitchAndFamily;
                lfFaceName = FaceName;
            }
        }
        public struct settextmode
        {
            Int32 dwForeColor; // forecolor, see macro RGB in win
            Int32 dwBackColor; // backcolor, see macro RGB in win
            Int32 dwSetMode; // 0:FULLCOPY, 1: FULLXOR, ...
            Int16 wFrameNo; // place which frame of target
            Int16 wReserved; // not used
            public settextmode(Int32 ForeColor, Int32 BackColor, Int32 SetMode, Int16 FrameNo, Int16 Reserved)
            {
                dwForeColor = ForeColor;
                dwBackColor = BackColor;
                dwSetMode = SetMode;
                wFrameNo = FrameNo;
                wReserved = Reserved;
            }
        }
        public struct POINT
        {
            public Int32 x;
            public Int32 y;
        }
        public unsafe struct BLOCKINFO
        {
            public Int16 iType;	//=BK or SQ, BM

            //need to fill when treat multi block else set 0
            public Int16 iWidth;		//width
            public Int16 iHeight;	//height
            public Int16 iBitCount; //pixel bytes iBitCount
            public Int16 iFormType;	//rgb format type, need to fill when RGB565 or RGB 555
            public Int16 lBlockStep; //block stride (step to next image header)
            public Int16 iHiStep;// HIWORD of block stride
            public Int16 lTotal;	//frame num
            public Int16 iHiTotal;// HIWORD of total
            public Int16 iInterval; //frame interval
            public byte* lpBits;// image data pointer / file path name
            public byte* lpExtra;
            //	public byte[] lpBits;
        }

        public struct PALETTEENTRY
        {
            public byte peRed;
            public byte peGreen;
            public byte peBlue;
            public byte peFlags;
        }


        [DllImport("user32.dll", CharSet = CharSet.Auto, ExactSpelling = true)]
        unsafe static extern public void GetClientRect(ref win32.RECT Rect);

        [DllImport("user32.dll", CharSet = CharSet.Auto, ExactSpelling = true)]
        unsafe internal static extern int MapWindowPoints(IntPtr hWndTo, System.Drawing.Point* pt, int cPoints);

        [DllImport("kernel32.dll")]
        unsafe static extern public System.IntPtr GlobalAlloc(Int32 uFlags, Int32 dwBytes);
        [DllImport("kernel32.dll")]
        unsafe static extern public void GlobalFree(System.IntPtr lpmemory);
        [DllImport("kernel32.dll")]
        unsafe static extern public Int32 GetTickCount();
        [DllImport("kernel32.dll")]
        unsafe static extern public void RtlZeroMemory(void* dest, Int32 lenght);
        [DllImport("kernel32.dll")]
        unsafe static extern public void RtlMoveMemory(void* dest, void* scour, Int32 lenght);

        [DllImport("kernel32.dll")]
        unsafe static extern public void RtlFillMemory(void* dest, Int32 lenght, byte fill);
        [DllImport("user32.dll")]
        unsafe static extern public Int32 ClientToScreen(System.IntPtr hwnd, win32.POINT* pt);
        [DllImport("user32.dll")]
        unsafe static extern public Int32 ScreenToClient(System.IntPtr hwnd, win32.RECT* rect);

        public win32()
        {
            // 
            // TODO: ڴ˴ӹ캯߼
            //
        }
    }
}
